Coin: SbList< Type > Class Template Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Protected Member Functions | List of all members
SbList< Type > Class Template Reference
Base Classes

The SbList class is a template container class for lists. More...

`#include <Inventor/lists/SbList.h>`

## Public Member Functions
| SbList (const int sizehint=DEFAULTSIZE)
| SbList (const SbList< Type > &l)
| ~SbList ()
void | copy (const SbList< Type > &l)
SbList< Type > & | operator= (const SbList< Type > &l)
void | fit (void)
void | append (const Type item)
int | find (const Type item) const
void | insert (const Type item, const int insertbefore)
void | removeItem (const Type item)
void | remove (const int index)
void | removeFast (const int index)
int | getLength (void) const
void | truncate (const int length, const int dofit=0)
void | push (const Type item)
Type | pop (void)
const Type * | getArrayPtr (const int start=0) const
Type | operator[] (const int index) const
Type & | operator[] (const int index)
int | operator== (const SbList< Type > &l) const
int | operator!= (const SbList< Type > &l) const
void | ensureCapacity (const int size)

## Protected Member Functions
void | expand (const int size)
int | getArraySize (void) const

## Detailed Description

template<typename Type>
class SbList< Type >

The SbList class is a template container class for lists.

SbList is an extension of the Coin library versus the original Open Inventor API. Open Inventor handles most list classes by inheriting the SbPList class, which contains an array of generic `void*` pointers. By using this template-based class instead, we can share more code and make the list handling code more typesafe.

Care has been taken to make sure the list classes which are part of the Open Inventor API to still be compatible with their original interfaces, as derived from the SbPList base class. But if you still bump into any problems when porting your Open Inventor applications, let us know and we'll do our best to sort them out.

A feature with this class is that the list object arrays grow dynamically as you append() more items to the list. The actual growing technique used is to double the list size when it becomes too small.

There are also other array-related convenience methods; e.g. finding item indices, inserting items at any position, removing items (and shrink the array), copying of arrays, etc.

See also
  SbPList

## Constructor & Destructor Documentation

## ◆ SbList() [1/2]

template<typename Type >

SbList< Type >::SbList | ( | const int | sizehint = DEFAULTSIZE | ) |
| inline

Default constructor.

The sizehint argument hints about how many elements the list will contain, so memory allocation can be done efficiently.

Important note: explicitly specifying an sizehint value does not mean that the list will initially contain this number of values. After construction, the list will contain zero items, just as for the default constructor. Here's a good example on how to give yourself hard to find bugs:

SbList<SbBool> flags(2); // Assume we need only 2 elements. Note
// that the list is still 0 elements long.
flags[0] = TRUE; // Ouch. List is still 0 elements long.
SbList
The SbList class is a template container class for lists.
Definition SbList.h:70

Since this conceptual misunderstanding is so easy to make, you're probably better (or at least safer) off leaving the sizehint argument to its default value by not explicitly specifying it.

It improves performance if you know the approximate total size of the list in advance before adding list elements, as the number of reallocations will be minimized.

## ◆ SbList() [2/2]

template<typename Type >

SbList< Type >::SbList | ( | const SbList< Type > & | l | ) |
| inline

Copy constructor. Creates a complete copy of the given list.

## ◆ ~SbList()

template<typename Type >

SbList< Type >::~SbList | ( |  | ) |
| inline

Destructor, frees all internal resources used by the list container.

## Member Function Documentation

## ◆ copy()

template<typename Type >

void SbList< Type >::copy | ( | const SbList< Type > & | l | ) |
| inline

Make this list a copy of l.

## ◆ operator=()

template<typename Type >

SbList< Type > & SbList< Type >::operator= | ( | const SbList< Type > & | l | ) |
| inline

Make this list a copy of l.

## ◆ fit()

template<typename Type >

void SbList< Type >::fit | ( | void |  | ) |
| inline

Fit the allocated array exactly around the length of the list, discarding memory spent on unused pre-allocated array cells.

You should normally not need or want to call this method, and it is only available for the sake of having the option to optimize memory usage for the unlikely event that you should throw around huge SbList objects within your application.

## ◆ append()

template<typename Type >

void SbList< Type >::append | ( | const Type | item | ) |
| inline

Append the item at the end of list, expanding the list array by one.

## ◆ find()

template<typename Type >

int SbList< Type >::find | ( | const Type | item | ) | const
| inline

Return index of first occurrence of item in the list, or -1 if item is not present.

## ◆ insert()

template<typename Type >

void SbList< Type >::insert | ( | const Type | item,
|  | const int | insertbefore )
| inline

Insert item at index insertbefore.

insertbefore should not be larger than the current number of items in the list.

## ◆ removeItem()

template<typename Type >

void SbList< Type >::removeItem | ( | const Type | item | ) |
| inline

Removes an item from the list. If there are several items with the same value, removes the item with the lowest index.

## ◆ remove()

template<typename Type >

void SbList< Type >::remove | ( | const int | index | ) |
| inline

Remove the item at index, moving all subsequent items downwards one place in the list.

## ◆ removeFast()

template<typename Type >

void SbList< Type >::removeFast | ( | const int | index | ) |
| inline

Remove the item at index, moving the last item into its place and truncating the list.

## ◆ getLength()

template<typename Type >

int SbList< Type >::getLength | ( | void |  | ) | const
| inline

Returns number of items in the list.

## ◆ truncate()

template<typename Type >

void SbList< Type >::truncate | ( | const int | length,
|  | const int | fit = 0 )
| inline

Shorten the list to contain length elements, removing items from index length and onwards.

If fit is non-zero, will also shrink the internal size of the allocated array. Note that this is much less efficient than not re-fitting the array size.

## ◆ push()

template<typename Type >

void SbList< Type >::push | ( | const Type | item | ) |
| inline

This appends item at the end of the list in the same fashion as append() does. Provided as an abstraction for using the list class as a stack.

## ◆ pop()

template<typename Type >

Type SbList< Type >::pop | ( | void |  | ) |
| inline

Pops off the last element of the list and returns it.

## ◆ getArrayPtr()

template<typename Type >

const Type * SbList< Type >::getArrayPtr | ( | const int | start = 0 | ) | const
| inline

Returns pointer to a non-modifiable array of the lists elements. start specifies an index into the array.

The caller is not responsible for freeing up the array, as it is just a pointer into the internal array used by the list.

## ◆ operator[]() [1/2]

template<typename Type >

Type SbList< Type >::operator[] | ( | const int | index | ) | const
| inline

Returns a copy of item at index.

## ◆ operator[]() [2/2]

template<typename Type >

Type & SbList< Type >::operator[] | ( | const int | index | ) |
| inline

Returns a reference to item at index.

## ◆ operator==()

template<typename Type >

int SbList< Type >::operator== | ( | const SbList< Type > & | l | ) | const
| inline

Equality operator. Returns `TRUE` if this list and l are identical, containing the exact same set of elements.

## ◆ operator!=()

template<typename Type >

int SbList< Type >::operator!= | ( | const SbList< Type > & | l | ) | const
| inline

Inequality operator. Returns `TRUE` if this list and l are not equal.

## ◆ ensureCapacity()

template<typename Type >

void SbList< Type >::ensureCapacity | ( | const int | size | ) |
| inline

Ensure that the internal buffer can hold at least size elements. SbList will automatically resize itself to make room for new elements, but this method can be used to improve performance (and avoid memory fragmentation) if you know approximately the number of elements that is going to be added to the list.

Since
  Coin 2.5

## ◆ expand()

template<typename Type >

void SbList< Type >::expand | ( | const int | size | ) |
| inlineprotected

Expand the list to contain size items. The new items added at the end have undefined value.

## ◆ getArraySize()

template<typename Type >

int SbList< Type >::getArraySize | ( | void |  | ) | const
| inlineprotected

Return number of items there's allocated space for in the array.

See also
  getLength()

The documentation for this class was generated from the following files:

- SoType.h
- SbList.h
- SbList.cpp